// WtWidget.js
//
// Copyright  2005, glenn andreas.	 All rights reserved
//


// protoWidget is a replacement for protoApp
protoWidget = View({
	_proto : protoView,
	viewClass : "widget",
	viewFlags : vVisible | vApplication,
	CreateElement : function() {
		// we don't create - we always exist
		return document.body;
	},
	KeyEvent : function(event) {
		var target = GetView('viewFrontKey');
		if (target && target.KeyEvent) {
			if (target.KeyEvent(event)) {
				event.stopPropagation();
			}
		}
		return false;
	},
	frontSide : null, // declared below
	backSide: null, // declared below
	ViewSetupFormScript : function() {
		this.sideShown = this.frontSide;
		var self = this;
		widget.onshow = function() { self.CallChildrenScripts('WidgetShowScript'); }
		widget.onhide = function() { self.CallChildrenScripts('WidgetHideScript'); }
		window.onfocus = function() {  self.CallChildrenScripts('WidgetFocusScript'); }
		window.onblur = function() {  self.CallChildrenScripts('WidgetBlurScript'); }
		widget.onremove = function() { self.CallChildrenScripts('WidgetRemoveScript'); }
		document.onmousewheel = function(event) {
			if (event.wheelDelta < 0) {
				self.CallChildrenScripts1('ViewScrollDownScript',event);
			} else {
				self.CallChildrenScripts1('ViewScrollUpScript',event);
			}
		}
	},
	ViewSetupDoneScript : function() {
		protoView.ViewSetupDoneScript.call(this);
		if (this.backSide && !this.backSide.bestSize) {
			// save the "default" size of the widget for the back
			this.backSide.bestSize = {width: this.viewElement.offsetWidth, height: this.viewElement.offsetHeight};
		}
		if (this.frontSide && !this.frontSide.bestSize) {
			this.frontSide.bestSize = {width: this.viewElement.offsetWidth, height: this.viewElement.offsetHeight};
		}
		this.CallChildrenScripts('WidgetStartupScript');
	},
	ViewShowScript : function() {
		// install global keyboard handler
		protoView.ViewShowScript.call(this);
		var self = this;
		this.viewElement.onkeypress = function(event) { self.KeyEvent(event); }
		// make sure the correct side is shown
		this.sideShown.ViewShowScript();
	},
	ShowFrontSide : function() {
		if (this.frontSide.bestSize) {
			// we changed sizes, so change back
			window.resizeTo(this.frontSide.bestSize.width, this.frontSide.bestSize.height);
		}
		widget.prepareForTransition("ToFront");
		this.backSide.Hide();
		this.frontSide.Show();
		setTimeout('widget.performTransition();',0);
		this.sideShown = this.frontSide;
	},
	ShowBackSide : function() {
		widget.prepareForTransition("ToBack");
		this.frontSide.Hide();
		if (this.backSide.bestSize) {
			// we changed sizes, so change back
			window.resizeTo(this.backSide.bestSize.width, this.backSide.bestSize.height);
		}
		this.backSide.Show();
		setTimeout('widget.performTransition();',0);
		this.sideShown = this.backSide;
	},
	ResizeTo : function(width, height) {
		if (width === document.width && height === document.height) {
			//return;
		}
		this.sideShown.bestSize = {width: width, height: height};
		window.resizeTo(width,height);
		//alert('Resize to ' + width + ', ' + height);
		this.viewElement.style.width = width;
		this.viewElement.style.height = height;
		this.sideShown.viewElement.style.left = 0;
		this.sideShown.viewElement.style.height = 0;
		this.sideShown.viewElement.style.width = width;
		this.sideShown.viewElement.style.height = height;
		this.sideShown.ReorientToScreen();
	},
	ResizeBy : function(dwidth, dheight) {
		if (dwidth === 0 && dheight === 0) {
			return;
		}
		this.sideShown.bestSize = {width: document.width + dwidth, height: document.height + dheight};
		window.resizeBy(dwidth,dheight);
		this.viewElement.style.width = document.width;
		this.viewElement.style.height = document.height;
		this.sideShown.viewElement.style.left = 0;
		this.sideShown.viewElement.style.height = 0;
		this.sideShown.viewElement.style.width = document.width;
		this.sideShown.viewElement.style.height = document.height;
		this.sideShown.ReorientToScreen();
	},
	CurrentWidth : function() {
		return window.innerWidth;
	},
	CurrentHeight : function() {
		return window.innerHeight;
	}
});


protoSide = View({
	_proto: protoView,
	viewClass : "side"
//	viewBounds : SetBounds(0,0,0,0),
//	viewJustify : vjParentFullH | vjParentFullV
});

protoSideFront = View({
	_proto: protoSide,
	viewElementId : 'frontSide',
	viewClass : 'frontSide'
});

protoIFlipper = View({
	_proto: protoView,
	iSymbol : null,
	iCircle : null,
	viewElementId : 'iFlipper',
	viewClass : 'iFlipper',
	viewStyle :	 { appleDashboardRegion : 'dashboard-region(control rectangle)'},
	viewBounds : RelBounds(-25,-31,13,13),
	viewJustify : vjParentRightH + vjParentBottomV,
	flipColor : "white",
	viewFlags : protoView.viewFlags | vClickable,
	ViewSetupChildrenScript: function() {
		protoView.ViewSetupChildrenScript.call(this);
		// set the color
	},
	ViewSetupDoneScript : function() {
		protoView.ViewSetupDoneScript.call(this);
		this.iSymbol.SlowHide(); // start with iSymbol shown
		this.iCircle.Hide();
	},
	ViewParentPointedScript : function(parent, event) {
		protoView.ViewParentPointedScript.call(this, parent, event);
		if (parent == this) {
			// we've moved over ourselves
			this.iCircle.Show();
		} else if (parent == this._parent) {
			// we've moved over 'front'
			this.iSymbol.SlowShow();
		}
	},
	ViewParentUnpointedScript : function(parent, event) {
		protoView.ViewParentPointedScript.call(this, parent, event);
		if (parent == this) {
			// we've moved over ourselves
			this.iCircle.Hide();
		} else if (parent == this._parent) {
			// we've moved over 'front'
			this.iSymbol.SlowHide();
		}
	},
	ViewClickScript : function(event) {
		this.iCircle.Hide();
		//this.iSymbol.SlowHide();
		this.ancestor().ShowBackSide();
		event.stopPropagation();
	}
});
DeclareStepChild(View({_proto: protoImgBackground, imageSrc: "Default.png"}), protoSideFront, 'backdropImage');
DeclareStepChild(protoIFlipper, protoSideFront, 'iflipper');
// we could use an animation, but those don't like stopping
// half way and continuing back the other way
mixinSlowFader = Mixin({
	targetOpacity : 0.0,
	SlowShow : function() {
		this.targetOpacity = 1.0;
		if (this.viewElement.style.opacity != 1.0) {
			this.SetupIdle(13);
		} else {
			this.SetupIdle(0);
		}
	},
	SlowHide : function() {
		this.targetOpacity = 0.0;
		if (this.viewElement.style.opacity != 0.0) {
			this.SetupIdle(13);
		} else {
			this.SetupIdle(0);
		}
	},
	ViewIdleScript : function() {
		var curOpacity = parseFloat(this.viewElement.style.opacity);
		if (!this.viewElement.style.opacity) {
			curOpacity = 1.0;
		}
		if (this.targetOpacity < curOpacity) {
			curOpacity -= 0.05;
			if (curOpacity < 0) { curOpacity = 0.0; }
		} else {
			curOpacity += 0.05;
			if (curOpacity > 1) { curOpacity = 1.0; }
		}
		this.viewElement.style.opacity = curOpacity;
		if (curOpacity == this.targetOpacity) {
			this.SetupIdle(0);
		}
	}
});

mixinSlowFaderRollover = Mixin({
	ViewParentPointedScript : function(parent, event) {
		protoView.ViewParentPointedScript.call(this, parent, event);
		if (parent == this) {
			// we've moved over ourselves
			this.SlowShow();
		}
	},
	ViewParentUnpointedScript : function(parent, event) {
		protoView.ViewParentPointedScript.call(this, parent, event);
		if (parent == this) {
			// we've moved over ourselves
			this.SlowHide();
		}
	}
});

protoIFlipRollie = View({
	_proto : protoView,
	_mixins : [mixinSlowFader],
	viewClass : 'iFlipRollie',
	viewStyle : {
		opacity: 0.5,
		background: "url(file:///System/Library/WidgetResources/ibutton/white_i.png) no-repeat top left",
		zIndex: 8000
	},
	viewBounds : RelBounds(0,0,13,13)
});
DeclareChild(protoIFlipRollie, protoIFlipper, 'iSymbol');

protoIFlipCircle = View({
	_proto: protoView,
	viewClass : 'iFlipCircle',
	viewStyle : {
		opacity: 0.25,
		background : "url(file:///System/Library/WidgetResources/ibutton/white_rollie.png) no-repeat top left",
		zIndex: 7999
	},
	viewBounds : RelBounds(0,0,13,13)
});

DeclareChild( protoIFlipCircle, protoIFlipper, 'iCircle');

protoDonePrefsButton = View({
	_proto: protoPushButton,
	viewElementId : 'donePrefsButton',
	defaultTitle: "Done",
	ButtonClickScript : function() {
		this.ancestor().ShowFrontSide();
	}
});

protoSideBack = View({
	_proto : protoSide,
	viewElementId : 'backSide',
	viewFlags : protoSide.viewFlags & (~vVisible),
	doneButton : null
});
DeclareStepChild(View({_proto: protoImgBackground, imageSrc: "Default_reverse.png"}), protoSideBack, 'backdropImage');
//DeclareStepChild(protoDonePrefsButton, protoSideBack, 'doneButton');

// we can now declare the front and back of a widget
DeclareStepChild(protoSideFront, protoWidget, 'frontSide');
DeclareStepChild(protoSideBack, protoWidget, 'backSide');
// and set up the default and background default


protoGrowBox = View({
	_proto : protoImage,
	viewElementId : 'growBox',
	viewClass : 'growBox',
	viewFlags : protoImage | vClickable | vVisible,
	resizeMinWidth : 100,
	resizeMaxHeight : 1000,
	resizeMinHeight : 100,
	resizeMaxHeight : 1000,
	viewBounds : RelBounds(-24,-30,12,12),
	viewJustify : vjParentRightH + vjParentBottomV,
	// private
	currentAdjustDX : 0,
	currentAdjustDY : 0,
	imageSrc : '/System/Library/WidgetResources/resize.png',
	ViewClickScript : function(event) {
		this.currentAdjustDX = 0;
		this.currentAdjustDY = 0;
		var self = this;
		var startWidth = GetView('viewFrontMostApp').CurrentWidth();
		var startHeight = GetView('viewFrontMostApp').CurrentHeight();
		// work in screen values so we can maintain a coordinate scheme as we resize
		var startScreenX = event.screenX;
		var startScreenY = event.screenY;
		var trackMouseMoveHandler = function(event) {
			var newWidth = startWidth + (event.screenX - startScreenX);
			var newHeight = startHeight + (event.screenY - startScreenY);
			var limitwh = self.ResizeAdjustScript(newWidth, newHeight);
			//window.resizeTo(limitwh.width, limitwh.height); // resizes the widget to follow the mouse movement
			GetView('viewFrontMostApp').ResizeTo(limitwh.width, limitwh.height);
			event.stopPropagation();
			event.preventDefault();
		};
		var trackMouseUpHandler = function(event) {
			// remove the handlers we added
			document.removeEventListener('mousemove', trackMouseMoveHandler, true);
			document.removeEventListener('mouseup', trackMouseUpHandler, true);
			event.stopPropagation();
			event.preventDefault();
			self.ResumeIdle();
		};
		document.addEventListener('mousemove', trackMouseMoveHandler, true);
		document.addEventListener('mouseup', trackMouseUpHandler, true);
		this.SuspendIdle(); // don't idle while traccking - ugly!!!
		return true;
	},
	ResizeAdjustScript : function(width, height) {
		if (width < this.resizeMinWidth) { width = this.resizeMinWidth;}
		if (width > this.resizeMaxWidth) { width = this.resizeMaxWidth;}
		if (height < this.resizeMinHeight) { height = this.resizeMinHeight;}
		if (height > this.resizeMaxHeight) { height = this.resizeMaxHeight;}
		return { width : width, height : height };
	}
});


protoDrawerWidget = View({
	_proto : protoWidget,
	AddDrawer : function(drawer) {
		if (!this.allDrawers) {
			this.allDrawers = [];
		}
		this.allDrawers.push(drawer);
	},
	ShowBackSide : function() {
		this.CloseDrawers();
		protoWidget.ShowBackSide.call(this);
	},
	ReopenDrawers : function() {
		if (this.extendedDrawers) {
			for (var i=0;i<this.extendedDrawers.length;i+=1) {
				this.extendedDrawers[i].ShowDrawer();
			}
		}
		this.extendedDrawers = null;
	},
	ShowFrontSide : function() {
		protoWidget.ShowFrontSide.call(this);
		// note that the side transition is probably not done yet
		if (this.extendedDrawers) {
			var self = this;
			var f = function() {
				self.ReopenDrawers();
			}
			setTimeout(f, 100);
		}
	},
	CloseDrawers : function() {
		this.extendedDrawers = [];
		if (this.allDrawers) {
			for (var i=0;i<this.allDrawers.length;i+=1) {
				if (this.allDrawers[i].IsExtended()){
					this.extendedDrawers.push(this.allDrawers[i]);
					//alert('Pre close ' + GetRoot().viewElement.offsetHeight);
					this.allDrawers[i].ForceShut(); // close all drawers immediately
					//alert('Post close ' + GetRoot().viewElement.offsetHeight);
				}
			}
			this.ResizeForDrawers();
			//alert('Resized ' + GetRoot().viewElement.offsetHeight);
			var self = this;
			var f = function() {
				self.ResizeForDrawers();
			}
			//setTimeout(f,1000);
		}
	},
	needToOpenDrawer : null,
	OpenDrawer : function(drawer) {
		// assume exclusive drawers
		if (drawer == this.needToOpenDrawer) {
			return;
		}
		this.needToOpenDrawer = null;
		if (this.allDrawers) {
			for (var i=0;i<this.allDrawers.length;i+=1) {
				if (this.allDrawers[i].CurrentSize() != 0){
					if (this.allDrawers[i] == drawer) {
						drawer.ShowDrawer(); // make sure it is openning
						return; // already open/openning
					} else if (this.allDrawers[i].Side() == drawer.Side()) { // same side, hide it
						this.allDrawers[i].HideDrawer();
						this.needToOpenDrawer = drawer;
					}
				}
			}
			if (this.needToOpenDrawer) {
				var self = this;
				var f = function() {
					var drawer = self.needToOpenDrawer;
					self.needToOpenDrawer = null;
					for (var i=0;i<self.allDrawers.length;i+=1) {
						if (self.allDrawers[i].CurrentSize() != 0){
							if (self.allDrawers[i] == drawer) {
								return; // already open/openning
							} else if (self.allDrawers[i].Side() == drawer.Side()) { // same side, wait for it to hide
								self.allDrawers[i].HideDrawer();
								self.needToOpenDrawer = drawer;
							}
						}
					}
					if (!self.needToOpenDrawer) {
						// everything else is closed
						drawer.ShowDrawer();
					} else {
						setTimeout(f, 100); // try again later
					}
				}
				setTimeout(f, 100); // let things close before reopenning
			} else {
				drawer.ShowDrawer(); // can open easily
			}
		}
	},
	drawerExtraWidth : 0,
	drawerExtraHeight : 0,
	ResizeForDrawers : function() {
		if (this.sideShown != this.frontSide) {
			return;
		}
		// for now, only support right and bottom drawers
		var width = document.width;
		var height = document.height;
		if (this.frontSide.bestSize) {
			width = this.frontSide.bestSize.width;
			height = this.frontSide.bestSize.height;
		}
			var extraWidth = 0;
			var extraHeight = 0;
			for (var i=0;i<this.allDrawers.length;i++) {
				var sticksOut = this.allDrawers[i].SticksOut();
				if (sticksOut.width > extraWidth) {
					extraWidth = sticksOut.width;
				}
				if (sticksOut.height > extraHeight) {
					extraHeight = sticksOut.height;
				}
			}
			this.drawerExtraWidth = extraWidth;
			this.drawerExtraHeight = extraHeight;
			this.viewElement.style.rightMargin = this.drawerExtraWidth;
			this.viewElement.style.bottomMargin = this.drawerExtraHeight;
			window.resizeTo(width + extraWidth,height + extraHeight);
	},
	CurrentWidth : function() {
		return protoWidget.CurrentWidth.call(this) - this.drawerExtraWidth;
	},
	CurrentHeight : function() {
		return protoWidget.CurrentHeight.call(this) - this.drawerExtraHeight;
	},
	ResizeTo : function(width, height) {
		this.sideShown.bestSize = {width: width, height: height};
		window.resizeTo(width + this.drawerExtraWidth,height + this.drawerExtraHeight);
		//alert('Resize to ' + width + ', ' + height);
		this.viewElement.style.width = width;// + this.drawerExtraWidth;
		this.viewElement.style.height = height;// + this.drawerExtraHeight;
		this.sideShown.viewElement.style.left = 0;
		this.sideShown.viewElement.style.height = 0;
		this.sideShown.viewElement.style.width = width;
		this.sideShown.viewElement.style.height = height;
		this.sideShown.viewElement.style.right = this.drawerExtraWidth;
		this.sideShown.viewElement.style.bottom = this.drawerExtraHeight;
		this.sideShown.ReorientToScreen();
	}
});

protoDrawer = View({
	_proto : protoView,
	viewStyle : {
		zIndex : -10
	},
	// use this.viewJustify flags: vjParentRightH for right, vjParentBottomV for bottom
	inited : false,
	isExtended : false,
	ViewSetupFormScript : function() {
		//if (!this.fullSize) {
		// grab the 'full' size and then hide it
		//this.fullSize = this.CurrentSize();
		if (!this.inited) {
			this.SetSize(0);
			GetView('viewFrontMostApp').AddDrawer(this);
		}
		this.inited = true;
	},
	CurrentSize : function() {
		//alert('drawer current size')
		if (((this.viewJustify & (vjParentFullH)) == vjParentRightH)) {
			return this.viewBounds.right - this.viewBounds.left;
		} else if (((this.viewJustify & (vjParentFullV)) == vjParentBottomV)) {
			return this.viewBounds.bottom - this.viewBounds.top;
		}
		//alert('no drawer current size');
		return 0;
	},
	Side : function() {
		if (((this.viewJustify & (vjParentFullH)) == vjParentRightH)) {
			return vjRightH;
		} else if (((this.viewJustify & (vjParentFullV)) == vjParentBottomV)) {
			return vjBottomV;
		}
		return 0;
	},
	animateDirection : 0,
	animation : null,
	SetSize : function(size) {
		if (size == 0) {
			this.Hide();
		} else {
			this.Show();
		}
		if ((this.viewJustify & (vjParentFullH)) == vjParentRightH) {
			this.viewBounds.right = this.viewBounds.left + size;
		} else if ((this.viewJustify & (vjParentFullV)) == vjParentBottomV) {
			this.viewBounds.bottom = this.viewBounds.top + size;
		}
	},
	SticksOut : function() {
		if ((this.viewJustify & (vjParentFullH)) == vjParentRightH) {
			return {width:this.viewBounds.right,  height: 0};
		} else if ((this.viewJustify & (vjParentFullV)) == vjParentBottomV) {
			return {width:0, height:this.viewBounds.bottom};
		}
	},
	AnimateFunction : function() {
		var size = this.CurrentSize();
		size += this.animateDirection;
		if (size < 0) {
			size = 0;
			clearInterval(this.animation);
			this.animation = null;
		} else if (size > this.fullSize) {
			size = this.fullSize;
			clearInterval(this.animation);
			this.animation = null;
			if (this.closeBox) {
				this.closeBox.Show();
			}
		}
		this.SetSize(size);
		GetView('viewFrontMostApp').ResizeForDrawers();
		this.ReorientToScreen(); // we changed size - use the reorient thing to lay things out
	},
	ShowDrawer : function() {
		// are we currently animating?
		if (this.animation) {
			this.animateDirection = 10; // make sure we're growing
		} else {
			if (this.fullSize != this.CurrentSize()) {
				var self = this;
				this.animateDirection = 5; // make sure we're growing
				var f = function() { self.AnimateFunction(); };
				this.animation = setInterval(f, 50);
			}
		}
		this.isExtended = true;
	},
	HideDrawer : function() {
		if (this.animation) {
			this.animateDirection = -20;
		} else {
			if (this.CurrentSize() != 0) {
				var self = this;
				this.animateDirection = -10;
				var f = function() { self.AnimateFunction(); };
				this.animation = setInterval(f, 50);
			}
		}
		if (this.closeBox) {
			this.closeBox.Hide();
		}
		this.isExtended = false;
	},
	Close : function() {
		this.HideDrawer();
	},
	IsExtended : function() {
		return this.isExtended;
		if (this.animation) {
			return this.animateDirection > 0;
		}
		return this.CurrentSize() != 0;
	},
	IsAnimating : function() {
		return this.animation;
	},
	ForceShut : function() {
		this.isExtended = false;
		if (this.animation) {
			clearInterval(this.animation);
			this.animation = null;
		}
		if (this.closeBox) {
			this.closeBox.Hide();
		}
		this.SetSize(0);
		this.ReorientToScreen(); // we changed size - use the reorient thing to lay things out
	}
});
protoAutoOpenDrawer = View({
	_proto : protoDrawer,
	IsExtended : function() {
		return true;
	}
});

protoCloseBox = View({
	_proto : protoPictureButton,
	icon : "Chrome/SmallClose",
	viewBounds : RelBounds(-30,-35,19,18),
	viewStyle : { zIndex: 10 },
	viewFlags : protoPictureButton.viewFlags & (~vVisible),
	viewJustify : vjParentBottomV | vjParentRightH,
	ButtonClickScript : function() {
		this._parent.Close();
	}
});
